import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The timer class for the game
 * 
 * @author Chandrasekhar Thotakura
 * @version 1.0.0
 */
public class LevelTimer  extends Info
{
    private long value;
    private long timer;
    private State state;
    
    /**
     * Constructor
     */
    public LevelTimer(long _limit)
    {
        this(_limit, "   Timer: ", false, java.awt.Color.BLACK, java.awt.Color.WHITE, CANVAS_W);
    }

    /**
     * Constructor
     */
    public LevelTimer(long _limit, String _padding, boolean _isStatic, java.awt.Color _bg, java.awt.Color _fg, int _width)
    {
        super(_padding, _isStatic, _bg, _fg, _width);
        value = _limit;
        state = State.T_STOPPED;
    }
    
    /**
     * start the timer
     */
    public void start()
    {
        state = State.T_STARTED;
    }

    /**
     * add the extra time for the timer
     */
    public void addTime(int amount)
    {
        value += amount;
        setInfo(""+value);
    }

    @Override
    public void act() 
    {
        if(world.gameState == State.GAMERUNNING)
        {
            super.act();
            myAct();
        }
    }
    
    public void myAct() 
    {
        if(state == State.T_STOPPED)
        {
            world.gameState = State.GAMEOVER;
        }
        else if(state == State.T_STARTED)
        {
            if(System.currentTimeMillis() - timer >= 1000)
            {
                timer = System.currentTimeMillis();
                value--;
                if(value < 0)
                {
                    state = State.T_STOPPED;
                }
                else if(value%10 == 0)
                {
                    //Dr.Karen requirement
                    //setInfo(""+value);
                    setInfoPassive(""+value);
                }
                else
                {
                    setInfoPassive(""+value);
                }
            }
        }
    }
}
