import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * All moving actors are the sub classes for this class
 * 
 * @author Chandrasekhar Thotakura
 * @version 1.0.0
 */
public class MovingActor extends CustomActor
{
    public static final double WALKING_SPEED = 3.0;

    /**
     * Move a bit in the given direction.
     */
    public boolean move(int direction)
    {
        return move(direction, WALKING_SPEED);
    }
    
    /**
     * Move a bit in the given direction.
     */
    public boolean move(int direction, double speed)
    {
        int x = 0;
        int y = 0;
        int diff = 0;

        /*x = getX()/WALL_W;
        y = getY()/WALL_W;
        diff = getX()%WALL_W;
        System.out.println("x = "+x);
        System.out.println("y = "+y);
        System.out.println("diff = "+diff);
        System.out.println("LEVEL[world.currentLevel][y+1][x-2] = "+LEVEL[world.currentLevel][y+1][x-2]);
        System.out.println("LEVEL[world.currentLevel][y+1][x-1] = "+LEVEL[world.currentLevel][y+1][x-1]);
        System.out.println("LEVEL[world.currentLevel][y+1][x] = "+LEVEL[world.currentLevel][y+1][x]);
        System.out.println("LEVEL[world.currentLevel][y+1][x+1] = "+LEVEL[world.currentLevel][y+1][x+1]);
        System.out.println("LEVEL[world.currentLevel][y+1][x+2] = "+LEVEL[world.currentLevel][y+1][x+2]);
        System.out.println("------------------------");
        System.out.println("LEVEL[world.currentLevel][y-2][x-2] = "+LEVEL[world.currentLevel][y-2][x-2]);
        System.out.println("LEVEL[world.currentLevel][y-2][x-1] = "+LEVEL[world.currentLevel][y-2][x-1]);
        System.out.println("LEVEL[world.currentLevel][y-2][x] = "+LEVEL[world.currentLevel][y-2][x]);
        System.out.println("LEVEL[world.currentLevel][y-2][x+1] = "+LEVEL[world.currentLevel][y-2][x+1]);
        System.out.println("LEVEL[world.currentLevel][y-2][x+2] = "+LEVEL[world.currentLevel][y-2][x+2]);
        System.out.println("========================");*/

        if(isMovable(direction, WALL_W+2))
        {
            switch(direction)
            {
                case DIR_R:
                    x = (int) Math.round(getX() + speed);
                    diff = getY()%WALL_W;
                    if(diff < GAP)
                    {
                        y = (getY()/WALL_W)*WALL_W;
                    }
                    else
                    {
                        y = (getY()/WALL_W+1)*WALL_W;
                    }
                    setLocation(x, y);
                break;
                case DIR_L:
                    x = (int) Math.round(getX() - speed);
                    diff = getY()%WALL_W;
                    if(diff < GAP)
                    {
                        y = (getY()/WALL_W)*WALL_W;
                    }
                    else
                    {
                        y = (getY()/WALL_W+1)*WALL_W;
                    }
                    setLocation(x, y);
                break;
                case DIR_D:
                    y = (int) Math.round(getY() + speed);
                    diff = getX()%WALL_W;
                    if(diff < GAP)
                    {
                        x = (getX()/WALL_W)*WALL_W;
                    }
                    else
                    {
                        x = (getX()/WALL_W+1)*WALL_W;
                    }
                    setLocation(x, y);
                break;
                case DIR_U:
                    y = (int) Math.round(getY() - speed);
                    diff = getX()%WALL_W;
                    if(diff < GAP)
                    {
                        x = (getX()/WALL_W)*WALL_W;
                    }
                    else
                    {
                        x = (getX()/WALL_W+1)*WALL_W;
                    }
                    setLocation(x, y);
                break;
                default:
                break;
            }
            return true;
        }
        else
        {
            switch(direction)
            {
                case DIR_R:
                    diff = getY()%WALL_W;
                    x = getX()/WALL_W;
                    y = getY()/WALL_W;
                    if(diff!= 0 && LEVEL[world.currentLevel][y][x+1] != 1 && LEVEL[world.currentLevel][y+1][x+1] != 1)
                    {
                        y = (y + 1) * WALL_W;
                        setLocation(getX(), y);
                    }
                    else if(diff!= 0 && LEVEL[world.currentLevel][y][x+1] != 1 && LEVEL[world.currentLevel][y-1][x+1] != 1)
                    {
                        y = y * WALL_W;
                        setLocation(getX(), y);
                    }
                break;
                case DIR_L:
                    diff = getY()%WALL_W;
                    x = getX()/WALL_W;
                    y = getY()/WALL_W;
                    if(diff!= 0 && LEVEL[world.currentLevel][y][x-2] != 1 && LEVEL[world.currentLevel][y+1][x-2]!= 1)
                    {
                        y = (y + 1) * WALL_W;
                        setLocation(getX(), y);
                    }
                    else if(diff!= 0 && LEVEL[world.currentLevel][y][x-2] != 1 && LEVEL[world.currentLevel][y-1][x-2] != 1)
                    {
                        y = y * WALL_W;
                        setLocation(getX(), y);
                    }
                break;
                case DIR_D:
                    diff = getX()%WALL_W;
                    x = getX()/WALL_W;
                    y = getY()/WALL_W;
                    if(diff!= 0 && LEVEL[world.currentLevel][y+1][x] != 1 && LEVEL[world.currentLevel][y+1][x+1] != 1)
                    {
                        x = (x + 1) * WALL_W;
                        setLocation(x, getY());
                    }
                    else if(diff!= 0 && LEVEL[world.currentLevel][y+1][x] != 1 && LEVEL[world.currentLevel][y+1][x-1] != 1)
                    {
                        x = x * WALL_W;
                        setLocation(x, getY());
                    }
                break;
                case DIR_U:
                    diff = getX()%WALL_W;
                    x = getX()/WALL_W;
                    y = getY()/WALL_W;
                    if(diff!= 0 && LEVEL[world.currentLevel][y-2][x] != 1 && LEVEL[world.currentLevel][y-2][x+1] != 1)
                    {
                        x = (x + 1) * WALL_W;
                        setLocation(x, getY());
                    }
                    else if(diff!= 0 && LEVEL[world.currentLevel][y-2][x] != 1 && LEVEL[world.currentLevel][y-2][x-1] != 1)
                    {
                        x = x * WALL_W;
                        setLocation(x, getY());
                    }
                break;
                default:
                break;
            }
        }
        return false;
    }

    /**
     * isMovable - This method is called to check whether the mover
     * can move in the direction specified or not.
     */
    protected boolean isMovable(int direction, int distance)
    {
        int h = this.getImage().getHeight();
        int w = this.getImage().getWidth();
        boolean movable = true;
        
        switch(direction)
        {
            case DIR_R:
                    for(int i=-(h/2-GAP); i<=h/2-GAP; i++)
                    {
                        if(this.getOneObjectAtOffset(distance, i, Wall.class) != null)
                        {
                            movable = false;
                            break;
                        }
                    }
                break;
            case DIR_L:
                    for(int i=-(h/2-GAP); i<=h/2-GAP; i++)
                    {
                        if(this.getOneObjectAtOffset(-1*distance, i, Wall.class) != null)
                        {
                            movable = false;
                            break;
                        }
                    }
                break;
            case DIR_D:
                    for(int i=-(w/2-GAP); i<=w/2-GAP; i++)
                    {
                        if(this.getOneObjectAtOffset(i, distance, Wall.class) != null)
                        {
                            movable = false;
                            break;
                        }
                    }
                break;
            case DIR_U:
                    for(int i=-(w/2-GAP); i<=w/2-GAP; i++)
                    {
                        if(this.getOneObjectAtOffset(i, -1*distance, Wall.class) != null)
                        {
                            movable = false;
                            break;
                        }
                    }
                break;
            default:
                break;
        }
        return movable;
    }    
}
