import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Power which makes the hero to shoot
 * 
 * @author Chandrasekhar Thotakura
 * @version 1.0.0
 */
public class Power  extends CustomActor
{
    private static final int ATTACK_POINTS = 500;

    /**
     * Constructor
     */
    protected Power()
    {
    }
    
    @Override
    public void act() 
    {
        if(world.gameState == State.GAMERUNNING)
        {
            myAct();
        }
    }

    public void myAct() 
    {
        if(getOneIntersectingObject(Hero.class) != null)
        {
            world.hero.gainPower();
            world.hero.gainPoints(ATTACK_POINTS);
            Greenfoot.playSound("gain.mp3");
            //world.info.setInfo("   Now you can use WASD keys to shoot at enemies.");
            world.changeCodeLine(2, 3);
            world.removeObject(this);
        }
    }    
}
