import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * The power to the ememy
 * 
 * @author Chandrasekhar Thotakura
 * @version 1.0.0
 */
public class Rings extends CustomActor
{
    private int size = 120;
    private int inc = 3;
    private int[] location = new int[5];
    
    /**
     * Constructor
     */
    public Rings()
    {
        setImage(new GreenfootImage(size, size));
        for(int i=0; i<location.length; i++)
        {
            location[i] = i*inc;
        }
    }
    
    /**
     * Act - do whatever the Rings wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    @Override
    public void act() 
    {
        if(world.gameState == State.GAMERUNNING)
        {
            drawRings();
            checkCollisionWithHero();
        }
    }
    
    /**
     * checkCollisionWithHero will check the collision with hero and hurts him if collided
     */
    public void checkCollisionWithHero()
    {
        //if(getOneIntersectingObject(Hero.class) != null)
        //{
        //    Greenfoot.stop();
        //}
        java.util.List list = getObjectsInRange(size/2 + WALL_W, Hero.class);
        if(list != null && list.size() > 0)
        {
            //INFO.setInfo("Boom");
            //Greenfoot.stop();
            world.hero.attackHero();
        }
    }
    
    /**
     * Act - do whatever the Rings wants to do. This method is called whenever
     */
    public void drawRings() 
    {
        GreenfootImage img = getImage();
        img.clear();
        //img.setColor(Color.WHITE);
        //img.fill();
        img.setColor(Color.BLACK);
        for(int i=0; i<location.length; i++)
        {
            img.drawOval(location[i], location[i], size - 2*location[i], size - 2*location[i]);
            location[i] += inc;
            if(location[i] >= size/2)
            {
                location[i] = 0;
            }
        }
        img.drawOval(0, 0, size, size);
        this.setImage(img);
    }    
}
